package com.example;

import java.io.*;
import java.util.*;
import java.util.logging.*;

import org.infinispan.client.hotrod.RemoteCache;
import org.infinispan.client.hotrod.RemoteCacheManager;
import org.infinispan.client.hotrod.MetadataValue;

import java.util.concurrent.TimeUnit;

public class App {
    public static void main(String[] args) throws Exception {
        // Logger.getLogger("").setLevel(Level.FINEST);

        String hostPort = "localhost:11222";
        String cacheName = "default";

        RemoteCacheManager cacheManager = new RemoteCacheManager(hostPort);
        RemoteCache<String, Object> cache = cacheManager.getCache(cacheName);

        String key = "aaa";
        System.console().printf("Key %s\n", key);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);
        cache.put(key, "value1", 100, TimeUnit.SECONDS, 100, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);
        cache.put(key, "value2", -1, TimeUnit.SECONDS, 100, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key)); // expected "value2", actual null
        sleep(1000L);
        cache.put(key, "value3", -1, TimeUnit.SECONDS, 100, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);

        key = "bbb";
        System.console().printf("Key %s\n", key);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);
        cache.put(key, "value1", 100, TimeUnit.SECONDS, 100, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);
        cache.put(key, "value2", 100, TimeUnit.SECONDS, -1, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key)); // expected "value2", actual null
        sleep(1000L);
        cache.put(key, "value3", 100, TimeUnit.SECONDS, -1, TimeUnit.SECONDS);
        sleep(1000L);
        dumpMetadata(cache.getWithMetadata(key));
        sleep(1000L);
    }

    private static void dumpMetadata(MetadataValue<Object> mdv) {
        if (mdv != null)
            System.console().printf("value %s, lifespan %d, maxIdle %d\n",
                   mdv.getValue(), mdv.getLifespan(), mdv.getMaxIdle());
        else
            System.console().printf("value null\n");
    }

    private static void sleep(long ms) throws InterruptedException {
        Thread.sleep(ms);
    }
}
